﻿Type=Activity
Version=2.71
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: false
#End Region

Sub Process_Globals
	Type FileData(Dir As String, FileName As String, KeyName As String, ContentType As String)
	Type IntentData (ShareIntent As Object, DetailsIntent As Object )
	Public mEventName As String
	Public mModule As Object
	
	
	Public  mIntentType As String '= "text/*"

	Public mSubject As String
	Public mText As String 
	
	Public mLineColor As Int 
	Public mHeaderText As String 
	Public mHeaderTextSize As Int 
	Public mHeaderTextColor As Int
	Public mHeaderBackColor As Int
	Public mTextSize As Int 
	Public mTextColor As Int
	Public mPadding As Int
	Public mButtonNormalColor As Int
	Public mButtonPressedColor As Int
	Public mShadowColor As Int
	Public mPanelColor As Int 
	Public mCornerRadius As Int
	
	Public mFaceBookAppID As String = ""
	Public mFaceBookRedirectUri As String = ""
	Public mSendingToFaceBook As String
	Public mSendingToFaceBookFinished As String 


	Private Shared As Boolean = False
	Dim  FilterList, FileList As List ',

	Public mAppButtonWidth As Int
	Public mAppButtonHeight As Int 
	Public mAppIconSize As Int
	Public mHeaderHeight As Int 

	Dim FBAccessToken As String
	Dim FBDataRequestLink As String = "https://graph.facebook.com/me/feed" '"https://graph.facebook.com/me/photos"
	Dim FBhc As HttpClient
	Dim FBreq As HttpRequest
End Sub

Sub Globals
	Dim ScreenWidth, Screenheight As Int 
	Dim aBg, pBg As ColorDrawable
	Dim btnColor, btnPressedColor As ColorDrawable
	Dim Cols As Int 

	Dim scvApps As ScrollView 
	Dim pnlBack As Panel
	Dim FacebookPage As WebView
End Sub

Sub Activity_Create(FirstTime As Boolean)
	If Not(FileList.IsInitialized) Then  FileList.Initialize 
	If Not(FilterList.IsInitialized) Then  FilterList.Initialize 
	
	scvApps.Initialize(10dip) 'Initialize ScrollView
	btnColor.Initialize(mButtonNormalColor,mCornerRadius) 'Initialize the ColoorDrawable for the App Buttons
	btnPressedColor.Initialize(mButtonPressedColor,mCornerRadius)

	aBg.Initialize(mShadowColor,0)
	pBg.Initialize(mPanelColor,2dip)
	Activity.Background = aBg
	
	Dim tmpwidth As Int = 100%x - 2*mPadding
	tmpwidth = Floor(tmpwidth / (mAppButtonWidth+mPadding))
	
	Cols = tmpwidth
	Screenheight = 100%y * 0.95
	ScreenWidth = (Cols * mAppButtonWidth+mPadding) + 2*mPadding 
	
	pnlBack.Initialize("")
	pnlBack.Background = pBg
	Activity.AddView(pnlBack,(100%x - ScreenWidth)/2,(100%y-Screenheight)/2,ScreenWidth,Screenheight)
	
	
	Dim lblHeaderBack As Panel
	lblHeaderBack.Initialize("")
	lblHeaderBack.Color = mHeaderBackColor
	pnlBack.AddView(lblHeaderBack,0dip,0dip,pnlBack.Width, mHeaderHeight)
	
	Dim lblHeader As Label
	lblHeader.Initialize("")
	lblHeader.Text = mHeaderText
	lblHeader.TextColor = mHeaderTextColor
	lblHeader.TextSize = mHeaderTextSize
	lblHeader.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL 
	lblHeaderBack.AddView(lblHeader,mPadding,0dip,pnlBack.Width-mPadding, mHeaderHeight)
	pnlBack.AddView(scvApps,0dip,mHeaderHeight+1dip,pnlBack.Width,pnlBack.Height - mHeaderHeight +1dip)
	

	Dim pnlLine As Panel
	pnlLine.Initialize("")
	pnlLine.Color = mLineColor
	pnlBack.AddView(pnlLine,0dip,scvApps.Top -2dip,pnlBack.Width,2dip)
	

	FacebookPage.Initialize("FacebookPage") 'The Webview for the FaceBook part
	FacebookPage.Visible = False
	Activity.AddView(FacebookPage,mPadding,mPadding,100%x- 2*mPadding,100%y- 2*mPadding)
	FBhc.Initialize("FBhc")
	
	CreateContentChooser
End Sub
'The Main Part.. get all the Apps for the Intent and show them
Private Sub CreateContentChooser
	

	Dim pm As  PackageManager
    Dim ShareIntent As Intent
	Dim Action As String
	
	'If more then 1 File added, there has to be an other Action send
	If FileList.Size > 1 Then
		Action = "android.intent.action.SEND_MULTIPLE"
	Else
		Action = "android.intent.action.SEND"
	End If
	
	ShareIntent.Initialize(Action, "")
	ShareIntent.SetType(mIntentType)
	
	Dim row As Int = 0
	Dim col As Int = 0
	Dim lastCol As Int = 0
	Dim PaddingLeft As Int = (pnlBack.Width - (Cols * mAppButtonWidth)) / 2

	'Circle through all Intents
	For Each cn As String In pm.QueryIntentActivities(ShareIntent)
		Try	
		Log(cn)
				'Skip the Packagage if in the FilterList
				Dim SkipPackage As Boolean = False
				Dim i As Int
				For i = 0 To FilterList.Size -1
					Dim tmpPackagename As String = FilterList.Get(i)
					If cn.ToLowerCase.Contains(tmpPackagename.ToLowerCase)  Then SkipPackage = True
				Next
				If SkipPackage = True Then Continue
				
				'Since we have no access to the Facebook Messenger => Skip it
				If cn.ToLowerCase.Contains("facebook") AND cn.ToLowerCase.Contains("orca") Then Continue

				
				Dim tmpIntent As Intent 
				tmpIntent.Initialize(Action, "")
				tmpIntent.SetType(mIntentType)
				tmpIntent.SetComponent(cn)
				If mSubject.Length > 0 Then  tmpIntent.PutExtra("android.intent.extra.SUBJECT", mSubject)
				If mText.Length > 0 Then  tmpIntent.PutExtra("android.intent.extra.TEXT", mText)

				Dim tmpPackageIntent As Intent
				tmpPackageIntent.Initialize("android.settings.APPLICATION_DETAILS_SETTINGS",CreateUri("package:" & cn.SubString2(0, cn.IndexOf("/"))))

				Dim tmpIntentData As IntentData
				tmpIntentData.Initialize
				tmpIntentData.DetailsIntent = tmpPackageIntent

				Dim pnl As Panel
				pnl.Initialize("pnl")
				
				If cn.ToLowerCase.Contains("facebook") AND cn.ToLowerCase.Contains("katana") Then
					If  mFaceBookAppID.Length <= 0 OR mFaceBookRedirectUri.Length <= 0 Then Continue
					pnl.Tag = Null
				Else
					
					If FileList.Size = 1 Then 
						Dim fd As FileData
						fd = FileList.Get(0)
						tmpIntent.PutExtra("android.intent.extra.STREAM", CreateUri("file://" & File.Combine(fd.Dir,fd.filename)))
					Else If FileList.Size > 1 Then
						Dim lstUri As List
						lstUri.Initialize 
						Dim i As Int
						Dim fd As FileData
						For i = 0 To FileList.Size -1
							fd = FileList.Get(i)
							lstUri.Add(CreateUri("file://" & File.Combine(fd.Dir,fd.filename)))
						Next
						tmpIntent.PutExtra("android.intent.extra.STREAM", lstUri)
					End If

					tmpIntentData.ShareIntent = tmpIntent
					pnl.Tag = tmpIntentData
				End If
				

				Dim sldButton As StateListDrawable
				sldButton.Initialize
				sldButton.AddState(sldButton.State_Pressed,btnPressedColor)
				sldButton.AddCatchAllState(btnColor)
				

				scvApps.Panel.AddView(pnl,(col * mAppButtonWidth + PaddingLeft)+1dip,row*mAppButtonHeight+1dip,mAppButtonWidth-1dip,mAppButtonHeight-1dip)
							
				pnl.Background = sldButton
				
				
				Dim package As String = cn
				package = package.SubString2(0, package.IndexOf("/"))

				Dim imgIcon As ImageView
				imgIcon.Initialize("")
				imgIcon.Gravity = Gravity.FILL
				imgIcon.Background = pm.GetApplicationIcon(package)
				pnl.AddView(imgIcon,pnl.Width/2 - mAppIconSize/2,pnl.Height/2 - mAppIconSize/2 - 10dip,mAppIconSize,mAppIconSize)
				
				
				Dim lbl As Label
				lbl.Initialize("")
				lbl.TextColor = mTextColor
				lbl.TextSize = mTextSize
				lbl.Gravity = Gravity.CENTER_HORIZONTAL + Gravity.TOP
				lbl.Text = pm.GetApplicationLabel(package)
				pnl.AddView(lbl,0dip,imgIcon.Top + imgIcon.Height ,pnl.Width,pnl.Height -imgIcon.Top -imgIcon.Height )

				col= col + 1
				lastCol = col
				If col >= Cols Then
					row = row+1
					col = 0
				End If
		Catch
		End Try
	Next
	
	If lastCol = Cols Then row = row -1

	scvApps.Panel.Height =(row+1) * mAppButtonHeight +1dip'+ iconheight
	If scvApps.Panel.Height < scvApps.Height Then
		
		scvApps.Height = scvApps.Panel.Height
		pnlBack.Height = mHeaderHeight + scvApps.Height +1dip
		pnlBack.Top = 100%y/2 - pnlBack.Height / 2
	End If
End Sub
'Click on App Icon => Start the corresponding intent
Private Sub pnl_Click
	Dim pnl As Panel
	pnl = Sender
	
	If pnl.Tag <> Null Then
		Try
			Dim ShareIntent As Intent
			Dim tmpIntentData As IntentData 
			tmpIntentData.Initialize
			tmpIntentData = pnl.Tag 
			ShareIntent = tmpIntentData.ShareIntent   'pnl.Tag
			Shared = True
			StartActivity(ShareIntent)
		Catch
			Msgbox(LastException,"Error")
		End Try
	Else
		Share
	End If
End Sub
'Long click on an App Icon => Show App Details
Sub pnl_LongClick
	Dim pnl As Panel
	pnl = Sender
	
	Try
		Dim ShareIntent As Intent
		Dim tmpIntentData As IntentData 
		tmpIntentData.Initialize
		tmpIntentData = pnl.Tag 
		ShareIntent = tmpIntentData.DetailsIntent  'pnl.Tag
		StartActivity(ShareIntent)	
	Catch
		Msgbox(LastException,"Error")
	End Try
End Sub
Private Sub FinishedSharing
	'Sharing is finished, so fire the Finished Event, set shared variable to false and finish activity
	If SubExists(mModule,mEventName&"_Finished") Then CallSubDelayed(mModule,mEventName&"_Finished")
	Shared = False
	Activity.Finish
End Sub
Private Sub Activity_Resume
	'Sharing is Finished...
	If Shared = True Then CallSub(Me,FinishedSharing)
End Sub
Private Sub Activity_Pause (UserClosed As Boolean)

End Sub
Private Sub Activity_Click
	Activity.Finish 
End Sub
'Creates an URI for the Intents
Private Sub CreateUri(uri As String) As Object
    Try
		Dim r As Reflector
    	Return r.RunStaticMethod("android.net.Uri", "parse", Array As Object(uri), Array As String("java.lang.String"))
	Catch
		Return ""
	End Try
End Sub
#Region FaceBook
'FaceBook Code by NJDude
Private Sub Share 
	If FBAccessToken = "" Then
	    Dim scope As String
		scope = "publish_stream"
		FacebookPage.Visible = True
		FacebookPage.LoadUrl("https://m.facebook.com/dialog/oauth?client_id=" & mFaceBookAppID & "&redirect_uri=" & mFaceBookRedirectUri & "&scope=" & scope & "&response_type=token")	 				
	Else
		PostWall
	End If
End Sub
Public Sub PostWall
    Dim nv As Map
	nv.Initialize
    
	Dim Message As StringBuilder
	Message.Initialize 
	If mSubject.Length >= 0 Then 
		Message.Append(mSubject  & CRLF & CRLF & mText)
	Else
		Message.Append (mText)
	End If
	
	nv.Put("message", Message.ToString )
	ProgressDialogShow(mSendingToFaceBook)
	
	If FileList.Size > 0 Then
	
		FBDataRequestLink = "https://graph.facebook.com/me/photos"
		FBreq = CreatePostRequest(FBDataRequestLink & "?access_token=" & FBAccessToken, nv,  FileList )
		
	Else
		FBDataRequestLink = "https://graph.facebook.com/me/feed"
		FBreq = CreatePostRequest(FBDataRequestLink & "?access_token=" & FBAccessToken, nv, Null)
	End If
	
	FBhc.Execute(FBreq, 1)
End Sub
Sub FacebookPage_PageFinished(Url As String)
    FacebookPage.Visible = False
	If Url.StartsWith("http://m.facebook.com/login.php") Then
		ProgressDialogHide
		FacebookPage.Visible = True
	End If

	If Url.StartsWith(mFaceBookRedirectUri & "#access_token=") Then
		FacebookPage.Visible = False
		FBAccessToken = Url.SubString((mFaceBookRedirectUri & "#access_token=").Length)
		FBAccessToken = FBAccessToken.SubString2(0, FBAccessToken.IndexOf("&"))
		PostWall
	End If
End Sub
Sub FBhc_ResponseSuccess(Response As HttpResponse, TaskId As Int)
	Response.Release			
	ProgressDialogHide
	ToastMessageShow(mSendingToFaceBookFinished, True)
	CallSub(Me,"FinishedSharing")
End Sub
Sub FBhc_ResponseError(Response As HttpResponse, Reason As String, StatusCode As Int, TaskId As Int)
	If Response <> Null Then
		Msgbox("Error: " & Response.GetString("UTF8") & " - " & Reason, "Error")
		Response.Release				
    End If			
End Sub
Sub CreatePostRequest(URL As String, NameValues As Map, Files As List) As HttpRequest
	   Dim boundary As String
	   boundary = "---------------------------1461124740692"
	   Dim stream As OutputStream
	   stream.InitializeToBytesArray(20)
	   Dim EOL As String
	   EOL = Chr(13) & Chr(10) 'CRLF constant matches Android end of line character which is chr(10).
	   Dim b() As Byte
	   If NameValues <> Null AND NameValues.IsInitialized Then
		     'Write the name/value pairs
		     Dim key, value As String
		     For I	= 0 To NameValues.Size - 1
		        key = NameValues.GetKeyAt(I)
		        value = NameValues.GetValueAt(I)
		        b = ("--" & boundary & EOL & "Content-Disposition: form-data; name="	& QUOTE & key & QUOTE & EOL & EOL & value & EOL).GetBytes("UTF8")
		        stream.WriteBytes(b, 0, b.Length)
		     Next				
	    End If
	    If Files <> Null AND Files.IsInitialized Then
		      'Write the files
		      Dim fd As FileData
		    For I = 0 To Files.Size - 1
				fd = Files.Get(I)
				b = ("--" & boundary & EOL & "Content-Disposition: form-data; name=" & QUOTE & fd.KeyName & QUOTE & "; filename=" & QUOTE & fd.FileName & QUOTE	& ";" & "Content-Type: " & EOL & fd.ContentType & EOL & EOL).GetBytes("UTF8")
				stream.WriteBytes(b, 0, b.Length)
				Dim In As InputStream
				In = File.OpenInput(fd.Dir, fd.FileName)
				File.Copy2(In, stream) 'Read the file and write it to the stream
				b = EOL.GetBytes("UTF8")
				stream.WriteBytes(b, 0, b.Length)
		    Next			
	    End If
					
	    b = (EOL & "--" & boundary & "--" & EOL).GetBytes("UTF8")
	    stream.WriteBytes(b, 0, b.Length)
	    b = stream.ToBytesArray

	    Dim request As HttpRequest
		request.InitializePost2(URL, b)
	    request.SetContentType("multipart/form-data; boundary=" & boundary)
	    request.SetContentEncoding("UTF8")
	    Return request		
End Sub
#End Region 