﻿Type=Class
Version=2.71
@EndOfDesignText@
#Event: Finished
'Class module
Sub Class_Globals
	Private mEventName As String
	Private mModule As Object
	Private  mIntentType As String = "text/*"
	
	Private mSubject As String = ""
	Private mText As String = ""
	
	Private mLineColor As Int = Colors.RGB(49,182,255)
	Private mHeaderText As String = "Choose"
	Private mHeaderTextSize As Int = 22
	Private mHeaderTextColor As Int = Colors.RGB(49,182,255)
	Private mHeaderBackColor As Int = Colors.Transparent 
	Private mTextSize As Int = 14
	Private mTextColor As Int = Colors.Black
	Private mPadding As Int = 10dip
	Private mButtonNormalColor As Int = Colors.White
	Private mButtonPressedColor As Int = Colors.RGB(29,162,235)
	Private mShadowColor As Int = Colors.ARGB(150,0,0,0)
	Private mPanelColor As Int = Colors.White 
	Private mCornerRadius As Int = 0dip
	
	Private mAppButtonWidth As Int = 160dip
	Private mAppButtonHeight As Int = 120dip
	Private mAppIconSize As Int = 48dip
	Private mHeaderHeight As Int = 60dip

	
	Private mFaceBookAppID As String = ""
	Private mFaceBookRedirectUri As String = ""
	Private mSendingToFaceBook As String = "Posting to Facebook..."
	Private mSendingToFaceBookFinished As String = "Posted to Facebook"
	
	'List for Adding the Files, List for the Filters
	Private FileList, FilterList As List
End Sub
'IntentType, for example "text/*" for Text, "image/jpeg" for jpg, "image/png" for png etc..
Public Sub getIntentType As String
	Return mIntentType
End Sub
Public Sub setIntentType (IntentType As String)
	mIntentType = IntentType
End Sub
'Subject (for E-Mail,..) set as android.intent.extra.SUBJECT
Public Sub getSubject As String
	Return mSubject
End Sub
Public Sub setSubject (Subject As String)
	mSubject = Subject
End Sub
'The Message. Set as android.intent.extra.TEXT
Public Sub getText As String
	Return mText
End Sub
Public Sub setText (Text As String)
	mText = Text
End Sub
'HeaderText of the ContentChooser
'Standard: Choose
Public Sub getHeaderText As String 
	Return mHeaderText
End Sub
Public Sub setHeaderText (HeaderText As String)
	mHeaderText = HeaderText
End Sub
'Color of the Seperatorline below the Header
'Standard: Colors.RGB(49,182,255)
Public Sub getLineColor As Int
	Return mLineColor
End Sub
Public Sub setLineColor (Color As Int)
	mLineColor = Color
End Sub
'TextSize of the Header
'Standard: 22
Public Sub getHeaderTextSize As Int
	Return mHeaderTextSize
End Sub
Public Sub setHeaderTextSize (TextSize As Int)
	mHeaderTextSize = TextSize
End Sub
'TextColor of the Header
'Standard: Colors.RGB(49,182,255)
Public Sub getHeaderTextColor As Int
	Return mHeaderTextColor
End Sub
Public Sub setHeaderTextColor (Color As Int)
	mHeaderTextColor = Color
End Sub
'BackColor of the Header
'Standard: Colors.Transparent 
Public Sub getHeaderBackColor As Int
	Return mHeaderBackColor
End Sub
Public Sub setHeaderBackColor (Color As Int)
	mHeaderBackColor = Color
End Sub
'TextSize of the Names of the displayed Packages.
'Standard: 14
Public Sub getTextSize As Int
	Return mTextSize
End Sub
Public Sub setTextSize (TextSize As Int)
	mTextSize = TextSize
End Sub
'Textcolor of the Names of the displayed Packages
'Standard: Colors.Black
Public Sub getTextColor As Int
	Return mTextColor
End Sub
Public Sub setTextColor (Color As Int)
	mTextColor = Color
End Sub
'Padding
'Standard: 10dip
Public Sub getPadding As Int
	Return mPadding
End Sub
Public Sub setPadding (Padding As Int)
	mPadding = Padding
End Sub
'Color of the unpressed Buttons
'Standard: colors.white
Public Sub getButtonNormalColor As Int
	Return mButtonNormalColor
End Sub
Public Sub setButtonNormalColor (Color As Int)
	mButtonNormalColor = Color
End Sub
'Color of the pressed Button
'Standard: Colors.RGB(29,162,235)
Public Sub getButtonPressedColor As Int
	Return mButtonPressedColor
End Sub
Public Sub setButtonPressedColor (Color As Int)
	mButtonPressedColor = Color
End Sub
'Color of the Background Shadow.
'Use colors.rgb(x,x,x) for opaque background, colors.argb(x,x,x,x) for Transparency
'Standard: Colors.ARGB(150,0,0,0)
Public Sub getShadowColor As Int
	Return mShadowColor
End Sub
Public Sub setShadowColor (Color As Int)
	mShadowColor = Color
End Sub
'Color of the ContentChooser Panel
'Standard: Colors.white
Public Sub getPanelColor As Int
	Return mPanelColor
End Sub
Public Sub setPanelColor (Color As Int)
	mPanelColor = Color
End Sub
'Corner radius of the Buttons
'Standard: 0dip
Public Sub getCornerRadius As Int
	Return mCornerRadius
End Sub
Public Sub setCornerRadius (CornerRadius As Int)
	mCornerRadius = CornerRadius
End Sub
'Width of the Buttons
'Standard: 160dip
Public Sub getAppButtonWidth As Int
	Return mAppButtonWidth
End Sub
Public Sub setAppButtonWidth (AppButtonWidth As Int)
	mAppButtonWidth = AppButtonWidth
End Sub
'Height of the Buttons
'Standard: 120dip
Public Sub getAppButtonHeight As Int
	Return mAppButtonHeight
End Sub
Public Sub setAppButtonHeight (AppButtonHeight As Int)
	mAppButtonHeight = AppButtonHeight
End Sub
'Size of the Images on the Buttons
'Standard: 48dip
Public Sub getAppIconSize As Int
	Return mAppIconSize
End Sub
Public Sub setAppIconSize (AppIconSize As Int)
	mAppIconSize = AppIconSize
End Sub
'Height of the Header
'Standard: 60dip
Public Sub getHeaderHeight As Int
	Return mHeaderHeight
End Sub
Public Sub setHeaderHeight (HeaderHeight As Int)
	mHeaderHeight = HeaderHeight
End Sub
'Your Facebook RedirectUri. Needed for publishing to FaceBook.
'Tutorial by NJDude: <link>http://www.basic4ppc.com/forum/basic4android-getting-started-tutorials/17739-tutorial-post-facebook-wall-via-b4a-app.html|http://www.basic4ppc.com/forum/basic4android-getting-started-tutorials/17739-tutorial-post-facebook-wall-via-b4a-app.html</link>
'Attention: If not set, FaceBook will not be available to share with
Public Sub getFaceBookRedirectUri As String
	Return mFaceBookRedirectUri
End Sub
Public Sub setFaceBookRedirectUri (FaceBookRedirectUri As String)
	If Not( FaceBookRedirectUri.EndsWith("/")) Then FaceBookRedirectUri= FaceBookRedirectUri & "/"
	mFaceBookRedirectUri = FaceBookRedirectUri
End Sub
'Your Facebook AppID. Needed for publishing to FaceBook.
'Tutorial by NJDude: <link>http://www.basic4ppc.com/forum/basic4android-getting-started-tutorials/17739-tutorial-post-facebook-wall-via-b4a-app.html|http://www.basic4ppc.com/forum/basic4android-getting-started-tutorials/17739-tutorial-post-facebook-wall-via-b4a-app.html</link>
'Attention: If not set, FaceBook will not be available to share with
Public Sub getFaceBookAppID As String
	Return mFaceBookAppID
End Sub
Public Sub setFaceBookAppID (FaceBookAppID As String)
	mFaceBookAppID = FaceBookAppID
End Sub
'The String displayed in the ProgressDialog while sending to FaceBook
'Standard: "Posting to Facebook..."
Sub getSendingToFaceBookString As String
	Return mSendingToFaceBook
End Sub
Sub setSendingToFaceBookString (SendingToFaceBookText As String)
	mSendingToFaceBook = SendingToFaceBookText
End Sub
'The String displayed as ToastMessage after Sending to Facebook succeeded
'Standard: "Posted to Facebook"
Sub getSendingToFaceBookFinishedString As String
	Return mSendingToFaceBookFinished
End Sub
Sub setSendingToFaceBookFinishedString ( SendingToFaceBookFinishedText As String)
	mSendingToFaceBookFinished = SendingToFaceBookFinishedText
End Sub

'Initializes the Library
'
'<B>Normal Library usage:</B>
'-----------------------
'<code>Dim Share as ahaShare
'Share.initialize(me, "Share")
'Share.FaceBookAppID = "xxxx"
'Share.FaceBookRedirectUri = "http://www.xxxxxx.xxx/"
'Share.Share("Test-Subject","Test-Text")</code>
'
'Event Finished will be raised when Sharing is finished:
'Sub Share_Finished
'	..your code here (i.e deleting temp files,...)
'End Sub
'
'<B>That's it :-)</B>
Public Sub Initialize(Module As Object, EventName As String) 
	mModule = Module
	mEventName = EventName
	FileList.Initialize 
	FilterList.Initialize 
End Sub
'Adds a file to the Intent
'<B>Attention: file.DirAssets and file.dirInternal will <I>NOT></I> work as Directory!!</B>
Public Sub AddFile(Directory As String, Filename As String)
	Dim fd As FileData
	fd.Initialize
    fd.Dir = Directory
    fd.Filename = Filename
    fd.KeyName 	= Filename
    fd.ContentType 	= "*/*" 
    FileList.Add(fd)
End Sub
'Adds a packagefilter. Packages with the given names will not be shown in the ContentChooser
'Example1: "com.google.android.keep" to hide Google Keep from the choosable Apps
'Example2: "synology" hides every Synology-App
Public Sub AddPackageFilter (PackageFilter As String)
	FilterList.Add(PackageFilter)
End Sub
'Clears all added files
Public Sub ClearFiles
	FileList.Clear 
End Sub
'Starts the ContentChooser
Public Sub Share (Subject As String, Text As String)
	mSubject = Subject
	mText = Text
	SetProperties
	ahaContentChooser.mIntentType = mIntentType 
	ahaContentChooser.FileList = FileList
	ahaContentChooser.FilterList  = FilterList
	ahaContentChooser.mModule = mModule
	ahaContentChooser.mEventName = mEventName
	StartActivity(ahaContentChooser)
End Sub
'Setting all the GUI Properties
Private Sub SetProperties
	ahaContentChooser.mButtonNormalColor=mButtonNormalColor
	ahaContentChooser.mButtonPressedColor=mButtonPressedColor
	ahaContentChooser.mCornerRadius=mCornerRadius
	ahaContentChooser.mHeaderText=mHeaderText
	ahaContentChooser.mHeaderTextColor=mHeaderTextColor
	ahaContentChooser.mHeaderBackColor = mHeaderBackColor 
	ahaContentChooser.mHeaderTextSize=mHeaderTextSize
	ahaContentChooser.mLineColor=mLineColor
	ahaContentChooser.mPadding=mPadding
	ahaContentChooser.mPanelColor=mPanelColor
	ahaContentChooser.mShadowColor=mShadowColor
	ahaContentChooser.mSubject=mSubject
	ahaContentChooser.mText=mText
	ahaContentChooser.mTextColor=mTextColor
	ahaContentChooser.mTextSize =mTextSize
	ahaContentChooser.mFaceBookAppID = mFaceBookAppID
	ahaContentChooser.mFaceBookRedirectUri = mFaceBookRedirectUri
	ahaContentChooser.mSendingToFaceBook = mSendingToFaceBook
	ahaContentChooser.mSendingToFaceBookFinished = mSendingToFaceBookFinished
	ahaContentChooser.mAppButtonWidth = mAppButtonWidth
	ahaContentChooser.mAppButtonHeight = mAppButtonHeight
	ahaContentChooser.mAppIconSize = mAppIconSize
	ahaContentChooser.mHeaderHeight = mHeaderHeight
End Sub